IF EXISTS (SELECT * FROM dbo.SysObjects WHERE id = object_id(N'dbo.AUDIT_upd_ALLOTMENTS') AND OBJECTPROPERTY(id, N'IsTrigger') = 1) DROP TRIGGER dbo.AUDIT_upd_ALLOTMENTS 
GO
CREATE TRIGGER [dbo].[AUDIT_upd_ALLOTMENTS]
ON [dbo].[ALLOTMENTS] FOR UPDATE NOT FOR REPLICATION AS
BEGIN
    

	DECLARE 
		@IDENTITY_SAVE			varchar(50),
		@AUDIT_LOG_TRANSACTION_ID	Int,
		@PRIM_KEY			nvarchar(4000),
		@Inserted	    		bit,
 		@ROWS_COUNT				int,
		@FK_UserIdNumber INT,
		@FK_CashBox INT,
		@ProgramPart SMALLINT,
		@TerminalName VARCHAR(50),
		@SystemDateStr VARCHAR(8),
		@SystemDateTime DATETIME
 
	SET NOCOUNT ON

	Select @ROWS_COUNT=count(*) from inserted
	SET @IDENTITY_SAVE = CAST(IsNull(@@IDENTITY,1) AS varchar(50))

    SELECT TOP 1 @FK_UserIdNumber = FK_UserIdNumber,
	@FK_CashBox = FK_CashBox,
	@ProgramPart = ProgramPart,
	@TerminalName = TerminalName
	FROM PersonnelLogInfo WITH (NOLOCK)
	WHERE spid = @@spid 
	ORDER BY CreateDate DESC

	IF ISNULL(@FK_UserIdNumber, 0) = 0
	  SET @FK_UserIdNumber = 1
	IF ISNULL(@FK_CashBox, -1) <= 0
	  SET @FK_CashBox = -1
	IF ISNULL(@ProgramPart, -1) <= 0
	  SET @ProgramPart = 14 -- ppUnknown from SystemAll
	IF ISNULL(@TerminalName, '') = ''
	  SET @TerminalName = 'Unknown'

    SELECT @SystemDateStr = SystemDate FROM System WITH (NOLOCK) WHERE Number = 1
    SET @SystemDateTime = CONVERT(DATETIME, @SystemDateStr + ' ' + CONVERT(CHAR(8), CURRENT_TIMESTAMP, 108))

	INSERT INTO dbo.AUDIT_LOG_TRANSACTIONS 
	(
		TABLE_NAME,
		TABLE_SCHEMA,
		AUDIT_ACTION_ID,
		HOST_NAME,
		APP_NAME,
		MODIFIED_BY,
		MODIFIED_DATE,
		AFFECTED_ROWS,
		FK_UserIdNumber,
		FK_CashBox,
		ProgramPart,
		TerminalName,
		RealDateTime
	)
	values(
		'ALLOTMENTS',
		'dbo',
		1,	--	ACTION ID For UPDATE
		CASE 
		  WHEN LEN(HOST_NAME()) < 1 THEN ' '
		  ELSE HOST_NAME()
		END,
		CASE 
		  WHEN LEN(APP_NAME()) < 1 THEN ' '
		  ELSE APP_NAME()
		END,
		SUSER_SNAME(),
		@SystemDateTime,
		@ROWS_COUNT,
		@FK_UserIdNumber,
		@FK_CashBox,
		@ProgramPart,
		@TerminalName,
		GETDATE()
	)	
	
	Set @AUDIT_LOG_TRANSACTION_ID = SCOPE_IDENTITY()
		
	SET @Inserted = 0
	
	If UPDATE([Name])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[AllotmentNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[AllotmentNumber], NEW.[AllotmentNumber]), 0), '[AllotmentNumber] Is Null')),
		    'Name',
			CONVERT(nvarchar(4000), OLD.[Name], 0),
			CONVERT(nvarchar(4000), NEW.[Name], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)=CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0) or (NEW.[AllotmentNumber] Is Null and OLD.[AllotmentNumber] Is Null))
			where (
			
			
				(
					NEW.[Name] <>
					OLD.[Name]
				) Or
			
				(
					NEW.[Name] Is Null And
					OLD.[Name] Is Not Null
				) Or
				(
					NEW.[Name] Is Not Null And
					OLD.[Name] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([Description])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[AllotmentNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[AllotmentNumber], NEW.[AllotmentNumber]), 0), '[AllotmentNumber] Is Null')),
		    'Description',
			CONVERT(nvarchar(4000), OLD.[Description], 0),
			CONVERT(nvarchar(4000), NEW.[Description], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)=CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0) or (NEW.[AllotmentNumber] Is Null and OLD.[AllotmentNumber] Is Null))
			where (
			
			
				(
					NEW.[Description] <>
					OLD.[Description]
				) Or
			
				(
					NEW.[Description] Is Null And
					OLD.[Description] Is Not Null
				) Or
				(
					NEW.[Description] Is Not Null And
					OLD.[Description] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([StartDate])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[AllotmentNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[AllotmentNumber], NEW.[AllotmentNumber]), 0), '[AllotmentNumber] Is Null')),
		    'StartDate',
			CONVERT(nvarchar(4000), OLD.[StartDate], 0),
			CONVERT(nvarchar(4000), NEW.[StartDate], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)=CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0) or (NEW.[AllotmentNumber] Is Null and OLD.[AllotmentNumber] Is Null))
			where (
			
			
				(
					NEW.[StartDate] <>
					OLD.[StartDate]
				) Or
			
				(
					NEW.[StartDate] Is Null And
					OLD.[StartDate] Is Not Null
				) Or
				(
					NEW.[StartDate] Is Not Null And
					OLD.[StartDate] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([EndDate])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[AllotmentNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[AllotmentNumber], NEW.[AllotmentNumber]), 0), '[AllotmentNumber] Is Null')),
		    'EndDate',
			CONVERT(nvarchar(4000), OLD.[EndDate], 0),
			CONVERT(nvarchar(4000), NEW.[EndDate], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)=CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0) or (NEW.[AllotmentNumber] Is Null and OLD.[AllotmentNumber] Is Null))
			where (
			
			
				(
					NEW.[EndDate] <>
					OLD.[EndDate]
				) Or
			
				(
					NEW.[EndDate] Is Null And
					OLD.[EndDate] Is Not Null
				) Or
				(
					NEW.[EndDate] Is Not Null And
					OLD.[EndDate] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([ReleaseDays])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[AllotmentNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[AllotmentNumber], NEW.[AllotmentNumber]), 0), '[AllotmentNumber] Is Null')),
		    'ReleaseDays',
			CONVERT(nvarchar(4000), OLD.[ReleaseDays], 0),
			CONVERT(nvarchar(4000), NEW.[ReleaseDays], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)=CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0) or (NEW.[AllotmentNumber] Is Null and OLD.[AllotmentNumber] Is Null))
			where (
			
			
				(
					NEW.[ReleaseDays] <>
					OLD.[ReleaseDays]
				) Or
			
				(
					NEW.[ReleaseDays] Is Null And
					OLD.[ReleaseDays] Is Not Null
				) Or
				(
					NEW.[ReleaseDays] Is Not Null And
					OLD.[ReleaseDays] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([HotelNumber])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[AllotmentNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[AllotmentNumber], NEW.[AllotmentNumber]), 0), '[AllotmentNumber] Is Null')),
		    'HotelNumber',
			CONVERT(nvarchar(4000), OLD.[HotelNumber], 0),
			CONVERT(nvarchar(4000), NEW.[HotelNumber], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)=CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0) or (NEW.[AllotmentNumber] Is Null and OLD.[AllotmentNumber] Is Null))
			where (
			
			
				(
					NEW.[HotelNumber] <>
					OLD.[HotelNumber]
				) Or
			
				(
					NEW.[HotelNumber] Is Null And
					OLD.[HotelNumber] Is Not Null
				) Or
				(
					NEW.[HotelNumber] Is Not Null And
					OLD.[HotelNumber] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([MarkAsDeleted])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[AllotmentNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[AllotmentNumber], NEW.[AllotmentNumber]), 0), '[AllotmentNumber] Is Null')),
		    'MarkAsDeleted',
			CONVERT(nvarchar(4000), OLD.[MarkAsDeleted], 120),
			CONVERT(nvarchar(4000), NEW.[MarkAsDeleted], 120),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[AllotmentNumber], 0)=CONVERT(nvarchar(4000), OLD.[AllotmentNumber], 0) or (NEW.[AllotmentNumber] Is Null and OLD.[AllotmentNumber] Is Null))
			where (
			
			
				(
					NEW.[MarkAsDeleted] <>
					OLD.[MarkAsDeleted]
				) Or
			
				(
					NEW.[MarkAsDeleted] Is Null And
					OLD.[MarkAsDeleted] Is Not Null
				) Or
				(
					NEW.[MarkAsDeleted] Is Not Null And
					OLD.[MarkAsDeleted] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	-- Watch
	
	-- Lookup
	
	IF @Inserted = 0
	BEGIN
		DELETE FROM dbo.AUDIT_LOG_TRANSACTIONS WHERE AUDIT_LOG_TRANSACTION_ID = @AUDIT_LOG_TRANSACTION_ID
	END
	-- Restore @@IDENTITY Value  
    DECLARE @maxprec AS varchar(2)
    SET @maxprec=CAST(@@MAX_PRECISION as varchar(2))
    EXEC('SELECT IDENTITY(decimal('+@maxprec+',0),'+@IDENTITY_SAVE+',1) id INTO #tmp')
End
